//
//  Audio_ToolModel.h
//  Audio Tool
//
//  Created by John Geelen on 9/15/11.
//  Copyright 2011 JG Electronics. All rights reserved.
//	Remarks, reports to: www.jgelectronics.nl.
//
//	Derived from Apple's example program DefaultOutputUnit.
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	Cocoa, OSX10.6 and XCODE 4.0.1
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#import <Foundation/Foundation.h>
#import <CoreAudio/CoreAudio.h>
#import <AudioToolbox/AudioToolbox.h>
#import <AudioUnit/AudioUnit.h>
/*
struct SynthData	//	used by method 1 and 2.  Audio_ToolModel.mm
{
	float				phase;
	float				frequency;
	float				pan;
	UInt32				waveForm;
};
*/
@interface Audio_ToolModel : NSObject {
//	struct SynthData	gSynthData;		//	used by method 1 and 2
	
//	used by method 3.  Audio_ToolModel.m
	float				phase;
	float				frequency;
	float				pan;
	UInt32				waveForm;
//

	AudioUnit			gOutputUnit;
//	THESE values can be read from your data source
//	they're used to tell the DefaultOutputUnit what you're giving it
	Float64				sSampleRate;
	SInt32				sNumChannels;
	SInt32				sWhichFormat;
	UInt32				sSinWaveFrameCount;		//	this keeps track of the number of frames you render
	
	UInt32				theFormatID;
//	these are set based on which format is chosen
	UInt32				theFormatFlags;
	UInt32				theBytesInAPacket;
	UInt32				theBitsPerChannel;
	UInt32				theBytesPerFrame;
//	these are the same regardless of format
	UInt32				theFramesPerPacket;			//	this shouldn't change
	UInt32				sampleNextPrinted;			//	print first time (UInt32)gSampleRate;
}

- (void)CreateDefaultAU;
- (void)TestDefaultAU;
- (void)CloseDefaultAU;
- (void)StartAudio;
- (void)StopAudio;
- (void)amSetWaveForm:(UInt32)waveFormInt;
- (void)amSetFrequency:(float)freqFlt;
- (void)amSetPan:(float)panFlt;
- (void)amSetamplitude:(float)amplFlt;
- (void)CloseDefaultAU;

@end