//
//  Display.m
//
//  Created by Kok Chen on 9/11/11.
//  Copyright 2011 Kok Chen, W7AY. All rights reserved.
//

#import "Display.h"


@implementation Display

- (void)drawRect:(NSRect)frame
{
//	ignore = YES ;
	[ backgroundColor set ] ;
	[ background fill ] ;
	[ borderColor set ] ;
	[ background stroke ] ;
	[ scaleColor set ] ;
	[ scale stroke ] ;
	if ( path ) {
		[ waveformColor set ] ;
		[ path stroke ] ;
	}
//	ignore = NO ;
}

- (void)addData:(float*)buffer samples:(int)samples
{
	float xgain, ygain, x, y ;
	int i ;
/*	
	if ( samples < 1 || ignore ) return ;
	skip = ( skip + 1 )%16 ;
	if ( skip != 0 ) return ;
*/
//	ignore = YES ;
	xgain = width/samples ;
//	NSLog(@"xgain= %f", xgain);
	ygain = height / 2;
	
//	NSLog(@"ygain= %f", ygain);
	[ path removeAllPoints ] ;
	
	for ( i = 0; i < samples; i++ ) {
		x = i*xgain ;
		
		y = height*0.5 + buffer[i]*ygain ;
	//	NSLog(@"y= %f", y);
		if ( i == 0 ) [ path moveToPoint:NSMakePoint( x, y ) ] ; else [ path lineToPoint:NSMakePoint( x, y ) ] ;
	}
	[ self setNeedsDisplay:YES ] ;
}

- (id)initWithFrame:(NSRect)frame 
{
	NSSize size ;
	int i ;
	float y ;
	CGFloat dash[2] = { 2.0, 1.0 } ;
	
    self = [ super initWithFrame:frame ] ;
    if ( self ) {
//		skip = 0 ;
//		ignore = NO ;
		bounds = [ self bounds ] ;
		size = bounds.size ;
		width = size.width ;
		height = size.height ;
		path = [ [ NSBezierPath alloc ] init ] ;
		background = [ [ NSBezierPath alloc ] init ] ;
		[ background appendBezierPathWithRect:bounds ] ;
		scale = [ [ NSBezierPath alloc ] init ] ;
		[ scale setLineDash:dash count:2 phase:0 ] ;
		
		for ( i = 1; i < 8; i++ ) {
			y = ( int )( height/8*i ) + 0.5 ;
			[ scale moveToPoint:NSMakePoint( 0, y ) ] ;
			[ scale lineToPoint:NSMakePoint( width, y ) ] ;
		}
		for ( i = 1; i < 10; i++ ) {
			y = ( int )( width/10*i ) + 0.5 ;
			[ scale moveToPoint:NSMakePoint( y, 0 ) ] ;
			[ scale lineToPoint:NSMakePoint( y, height ) ] ;
		}
		[ ( backgroundColor = [ NSColor colorWithDeviceRed:0.3 green:0.5 blue:0.6 alpha:1 ] ) retain ] ;
		[ ( waveformColor = [ NSColor colorWithCalibratedRed:0 green:1.0 blue:0.1 alpha:1 ] ) retain ] ;
		[ ( scaleColor = [ NSColor colorWithCalibratedRed:0.15 green:0.2 blue:0.2 alpha:0.5 ] ) retain ] ;
		[ ( borderColor = [ NSColor colorWithCalibratedRed:0.25 green:0.2 blue:0.1 alpha:1 ] ) retain ] ;
	}
	return self ;
}

- (void)dealloc
{
	if ( path ) [ path release ] ;
	[ background release ] ;
	[ borderColor release ] ;
	[ backgroundColor release ] ;
	[ waveformColor release ] ;
	[ scaleColor release ] ;
	[ super dealloc ] ;
}

@end
